#include "test_tools.h"
#include <hugo/smart_graph.h>
#include <hugo/dfs.h>

using namespace hugo;

const int PET_SIZE =5;


void check_Dfs_SmartGraph_Compile() 
{
  typedef int VType;
  typedef SmartGraph Graph;

  typedef Graph::Edge Edge;
  typedef Graph::Node Node;
  typedef Graph::EdgeIt EdgeIt;
  typedef Graph::NodeIt NodeIt;
  typedef Graph::EdgeMap<VType> LengthMap;
 
  typedef Dfs<Graph> BType;
  
  Graph G;
  Node n;
  Edge e;
  VType l;
  bool b;
  BType::DistMap d(G);
  BType::PredMap p(G);
  BType::PredNodeMap pn(G);
  LengthMap cap(G);
  
  BType dfs_test(G);
  
  dfs_test.run(n);
  
  l  = dfs_test.dist(n);
  e  = dfs_test.pred(n);
  n  = dfs_test.predNode(n);
  d  = dfs_test.distMap();
  p  = dfs_test.predMap();
  pn = dfs_test.predNodeMap();
  b  = dfs_test.reached(n);

}

int main()
{
    
  typedef SmartGraph Graph;

  typedef Graph::Edge Edge;
  typedef Graph::Node Node;
  typedef Graph::EdgeIt EdgeIt;
  typedef Graph::NodeIt NodeIt;
  typedef Graph::EdgeMap<int> LengthMap;

  Graph G;
  Node s, t;
  PetStruct<Graph> ps = addPetersen(G,PET_SIZE);
   
  s=ps.outer[2];
  t=ps.inner[0];
  
  Dfs<Graph> dfs_test(G);
  dfs_test.run(s);  
  
  for(NodeIt v(G); v!=INVALID; ++v) {
    check(dfs_test.reached(v),"Each node should be reached.");
    if ( dfs_test.pred(v)!=INVALID ) {
      Edge e=dfs_test.pred(v);
      Node u=G.tail(e);
      check(u==dfs_test.predNode(v),"Wrong tree.");
      check(dfs_test.dist(v) - dfs_test.dist(u) == 1,
	    "Wrong distance." << dfs_test.dist(v) << " " <<dfs_test.dist(u) );
    }
  }
}

